Subject: [Technical Errata Reported] RFC5952 (4483)

From: RFC Errata System <[email-masked]>
Date: Sat, 26 Sep 2015 17:43:58 -0700 (PDT)

The following errata report has been submitted for RFC5952,
"A Recommendation for IPv6 Address Text Representation".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata_search.php?rfc=5952&eid=4483

--------------------------------------
Type: Technical
Reported by: André Melancia <[email-masked]>

Section: 4.3

Original Text
-------------
—

Corrected Text
--------------
—

Notes
-----
Errata ID 2656, reported by D. Stussy in 2010-12-02 is CORRECT and perfectly justified.
This was however rejected on 2012-05-30. Justification on "verified notes" states "This errata is attempting to overturn the clear consensus of the WG.", which is WRONG, since WG consensus applies to the whole document, not specifically to section 4.3 or its unjustified and arbitrary lowercase conventioning.
There is no technical reason why lowercase "must" or "should" be used, instead, HISTORICALLY (which for any IETF work has been the "de facto" rule) uppercase has been used (see full justification in Errata ID 2656 mentioned above).
Additionally, and considering that modern devices are able to properly handle case changes without performance losses, the WG should discuss removing this rule altogether.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party (IESG)
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC5952 (draft-ietf-6man-text-addr-representation-07)
--------------------------------------
Title               : A Recommendation for IPv6 Address Text Representation
Publication Date    : August 2010
Author(s)           : S. Kawamura, M. Kawashima
Category            : PROPOSED STANDARD
Source              : IPv6 Maintenance
Area                : Internet
Stream              : IETF
Verifying Party     : IESG

---

From: Mark Smith <[email-masked]>
Date: Sun, 27 Sep 2015 12:33:01 +1000

On 27 Sep 2015 10:44, "RFC Errata System" <[email-masked]> wrote:
> This was however rejected on 2012-05-30. Justification on "verified
notes" states "This errata is attempting to overturn the clear consensus of
the WG.", which is WRONG, since WG consensus applies to the whole document,
not specifically to section 4.3 or its unjustified and arbitrary lowercase
conventioning.

My 2 bits.

This should be rejected, as consensus on the whole of a document inherently
implies consensus on specific parts of it.

> There is no technical reason why lowercase "must" or "should" be used,
instead, HISTORICALLY (which for any IETF work has been the "de facto"
rule) uppercase has been used (see full justification in Errata ID 2656
mentioned above).
> Additionally, and considering that modern devices are able to properly
handle case changes without performance losses, the WG should discuss
removing this rule altogether.
> --------------------------------------------------------------------
> IETF IPv6 working group mailing list
> [email-masked]
> Administrative Requests: https://www.ietf.org/mailman/listinfo/ipv6
> --------------------------------------------------------------------
>

---

From: Sander Steffann <[email-masked]>
Date: Sun, 27 Sep 2015 15:56:03 +0200

Hi,

> This should be rejected, as consensus on the whole of a document inherently implies consensus on specific parts of it.

+1

> > Additionally, and considering that modern devices are able to properly handle case changes without performance losses, the WG should discuss removing this rule altogether.

This sound like a personal opinion, not an errata.

Cheers,
Sander

---

From: Brian E Carpenter <[email-masked]>
Date: Mon, 28 Sep 2015 08:23:33 +1300

>> This should be rejected, as consensus on the whole of a document inherently implies consensus on specific parts of it.

Agreed.

> This sound like a personal opinion, not an errata.

Absolutely. The use of upper case arose simply because most I/O devices in the
1950s and 1960s didn't have lower case characters. There wasn't any other reason for
it and we've all had lower case since, let's see, the DECwriter II and the VT05 came
out in the early 1970s. There's no reason to set the clock back 40 years.

   Brian

---

From: "Manfredi, Albert E" <[email-masked]>
Date: Sun, 27 Sep 2015 22:41:20 +0000

> -----Original Message-----
> From: ipv6 [mailto:[email-masked]] On Behalf Of Sander Steffann
> Sent: Sunday, September 27, 2015 09:56
> To: Mark Smith
> Cc: [email-masked]; [email-masked]; [email-masked];
> [email-masked]; RFC Errata System; [email-masked]
> Subject: Re: [Technical Errata Reported] RFC5952 (4483)
> 
> Hi,
> 
> > > Notes
> > > -----
> instead, HISTORICALLY (which for any IETF work has been the "de facto" rule)
> uppercase has been used (see full justification in Errata ID 2656 mentioned
> above).

I was surprised to see this issue being resurrected. IMO, while I agree that general consensus on a document does not in principle constitute complete acceptance of each paragraph, clearly this business about upper or lower case, for IPv6 addresses, is one of the main points of RFC 5952. It is not some obscure side issue. And more importantly, the question has been discussed quite specifically in the wg. Just about everyone who has commented seems to want consistency, and lower case consistency to boot. I feel more on the fence about this than anyone else who has commented.

At the same time, it's undeniable that upper case is the norm, for formal representation of hex values.

Consequently, I have to say that the errata doesn't represent the wg consensus.

Vox populi est vox dei.

Bert

---

From: Mark Smith <[email-masked]>
Date: Mon, 28 Sep 2015 09:10:21 +1000

> > instead, HISTORICALLY (which for any IETF work has been the "de facto"
rule)
> I was surprised to see this issue being resurrected. IMO, while I agree
that general consensus on a document does not in principle constitute
complete acceptance of each paragraph, clearly this business about upper or
lower case, for IPv6 addresses, is one of the main points of RFC 5952. It
is not some obscure side issue. And more importantly, the question has been
discussed quite specifically in the wg. Just about everyone who has
commented seems to want consistency, and lower case consistency to boot. I
feel more on the fence about this than anyone else who has commented.
> At the same time, it's undeniable that upper case is the norm, for formal
representation of hex values.

While upper case is canonical, it has been quite common for IEEE MAC
addresses to be shown in lower case e.g. Cisco format, Sun OS format and
many other unices formats.

It makes a lot of sense from an operator entry POV, as the default case for
keyboards is lower. That might be an explanation for why IEEE MAC canonical
format isn't all that common. Capslock should make that easy, however I
find that because I don't use it very often, using capslock is a bit
"clunky" when I try to - I forget it is on, then switch it off, then have
to fix the text that is now in upper case but shouldn't be.

Ease of entry doesn't seem to be specifically called out in RFC5952,
although a number of topics go close.

---

From: Bob Hinden <[email-masked]>
Date: Sun, 27 Sep 2015 20:48:52 -0700

Hi,

> On Sep 27, 2015, at 6:56 AM, Sander Steffann <[email-masked]> wrote:
> 
> Hi,
> 
>>> Notes
>>> -----

I agree.

> This sound like a personal opinion, not an errata.

I also agree, but I do wonder now that the issue has been raised, if the requirement for a single case (i.e., lower case) is necessary.  All of the other recommendations in the RFC about the use of zeros, ::’s, etc. are very good.  I would think it's easy do case insensitive comparisons.  Even spreadsheets have the ability to covert the case of fields when doing comparisons.

To be clear, this is a question for the working group, not how this errata should be handled.

Bob

---

From: Sander Steffann <[email-masked]>
Date: Mon, 28 Sep 2015 15:38:46 +0200

Hi,

> I also agree, but I do wonder now that the issue has been raised, if the requirement for a single case (i.e., lower case) is necessary.  All of the other recommendations in the RFC about the use of…

Personally I like the upper-case notation. It just feels "natural" for hex digits. But going from "MUST be lower case" to "MUST be upper case" would be a bad idea. If we change anything then we should allow both.

I'm sure I will make the mistake for searching in a case-sensitive way, but that's just because of habit :)  And I probably have some scripts that would break if their input suddenly becomes upper-case, just because at the time I wrote them I knew their input would be lower-case.

So, all things considered, I think we should leave it as it is. Allowing upper case would be nice, but if it breaks existing code then it's not worth it.

Cheers,
Sander